<?php
  chdir('../../../../');
  require('includes/application_top.php');

  require('includes/modules/payment/mypos_virtual.php');

  if (!defined('MODULE_PAYMENT_MYPOS_VIRTUAL_STATUS') || (MODULE_PAYMENT_MYPOS_VIRTUAL_STATUS  != 'True')) {
    echo 'MODULE NOT INSTALLED';
    exit;
  }

  $payment = new mypos_virtual();

  $result = $payment->is_valid_signature($_POST);

  if ($result) {

      if ($_POST['IPCmethod'] == 'IPCPurchaseNotify') {

          global $HTTP_POST_VARS, $currencies;

          if (MODULE_PAYMENT_MYPOS_VIRTUAL_TEST_MODE == 'True') {
              $HTTP_POST_VARS['OrderID'] = str_replace(MODULE_PAYMENT_MYPOS_VIRTUAL_TEST_PREFIX, '', $HTTP_POST_VARS['OrderID']);
          }

          if (isset($HTTP_POST_VARS['OrderID']) && is_numeric($HTTP_POST_VARS['OrderID']) && ($HTTP_POST_VARS['OrderID'] > 0)) {
              $order_query = tep_db_query("select orders_id, orders_status, currency, currency_value from " . TABLE_ORDERS . " where orders_id = '" . (int)$HTTP_POST_VARS['OrderID'] . "'");

              if ( tep_db_num_rows($order_query) === 1 ) {
                  $order = tep_db_fetch_array($order_query);

                  $new_order_status = 2;

                  $comment_status = 'Transaction ID: ' . $HTTP_POST_VARS['IPC_Trnref'] . '; ';

                  tep_db_query("update " . TABLE_ORDERS . " set orders_status = '" . (int)$new_order_status . "', last_modified = now() where orders_id = '" . (int)$order['orders_id'] . "'");

                  $source = 'myPOS Checkout Verified';

                  $sql_data_array = array('orders_id' => (int)$order['orders_id'],
                      'orders_status_id' => 2,
                      'date_added' => 'now()',
                      'customer_notified' => '0',
                      'comments' => $source . ' [' . tep_output_string_protected($comment_status) . ']');

                  tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

                  echo 'OK';
              } else {
                  echo 'ORDER DOES NOT EXIST';
              }
          } else {
              echo 'INVALID ORDER ID';
          }
      } else {
          echo 'INVALID METHOD';
      }
  } else {
      echo 'INVALID SIGNATURE';
  }

  tep_session_destroy();
?>
